# File:     bad-ads.ps1
# Name:     Joseph.Gerwing
# Date:     20200731
# Desc:     Creating and Executiong Malicious Alternate Data Streams
# Usage:    powershell_ise.exe .\bad-ads.ps1 (Be in an elevated PowerShell ISE prompt)
# Note:     Script is meant to be ran incrementally using PowerShell ISE's 'run selection' or 'F8' option for each line in script

#---- Creating a Malicious Alternate Data Stream ----#

#-- From PowerShell ISE --#

# Create a file 'test.txt' with content 'Nothing to see here!'
Write-Output "Nothing to see here!" > test.txt

# Add ADS content sequentially
Add-Content -Path .\test.txt -Value 'Dim oShell' -Stream 'secret.vbs'
Add-Content -Path .\test.txt -Value 'Set oShell = Wscript.CreateObject ("Wscript.Shell")' -Stream 'secret.vbs'
Add-Content -Path .\test.txt -Value 'oShell.run "cmd /k CD C:\Program Files & ping 8.8.8.8" ,1 , true ' -Stream 'secret.vbs'

# Verify file and contents - Nothing has changed visibly
Get-Content .\test.txt
Get-Content .\test.txt -Stream secret.vbs

#---- Execute Malicious Alternate Data Stream ----#

# Execute Script contained in ADS content
wscript .\test.txt:secret.vbs

#-- From CMD.exe --#

# Run 'Certutil' to check the hash of the file.
Certutil -hashfile test.txt MD5

# Open ADS content in notepad and make changes.
notepad test.txt:secret.vbs
##add any text to the file and save it##
MORE < test.txt:secret.vbs

# Rerun Certutil - notice the MD5 hash doesn't change.
Certutil -hashfile test.txt MD5

# Question: Why did the MD5 hash not change?
# Answer: Many third party utilities only look at the main $DATA stream. The MD5 hash of the file will remain unchanged as long as data isn't changed in the main stream.
