#!/bin/bash
if : ; then
# File:         alias.sh
# Name:         Kevin Crotty
# Date:         6 May 2019
# Desc:         Show alias usage
# Usage:        alias.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

#function colorComment { echo -e "\n${BGreen}${1}${NC}" }
#function colorCommand { echo -e "${BRed}${1}${NC}" }
fi

echo && echo

echo -e "${BPurple}john@debian:~$ ${BRed}alias${NC}"
echo -e "alias ls='ls --color=auto'\n"
echo -e "${BPurple}john@debian:~$ ${BRed}alias l='ls -l'${NC}"
echo -e "${BPurple}john@debian:~$ ${BRed}alias c=clear${NC}"
echo -e "${BPurple}john@debian:~$ ${BRed}alias${NC}"
echo -e "alias c='clear'"
echo -e "alias l='ls -l'"
echo -e "alias ls='ls --color=auto'\n"
echo -e "${BPurple}john@debian:~$ ${BRed}unalias l${NC}"
echo -e "${BPurple}john@debian:~$ ${BRed}alias${NC}"
echo -e "alias c='clear'"
echo -e "alias ls='ls --color=auto'\n"
echo -e "${BPurple}john@debian:~$ ${BRed}alias folder='/var/log'${NC}"
echo -e "${BPurple}john@debian:~$ ${BRed}cd folder${NC}"
echo -e "bash: cd: folder: No such file or directory\n"
echo -e "${BPurple}john@debian:~$ ${BRed}alias folder='cd /var/log'${NC}"
echo -e "${BPurple}john@debian:~$ ${BRed}folder${NC}"
echo -e "${BPurple}john@debian:/var/log$ ${BRed}alias ls=clear${NC}"
echo -e "${BPurple}john@debian:/var/log$ ${BRed}alias ls=pwd${NC}"
echo -e "${BPurple}john@debian:/var/log$ ${BRed}ls${NC}"
echo -e "/var/log\n"
echo -e "${BPurple}john@debian:/var/log$ ${BRed}\ls -1 | head -n5${NC}"
echo -e "alternatives.log"
echo -e "alternatives.log.1"
echo -e "apache2"
echo -e "apt"
echo -e "audit\n"
echo -e "${BPurple}john@debian:/var/log$ ${BRed}exit${NC}"
echo -e "exit\n"
echo -e "${BPurple}root@debian$ ${BRed}su john${NC}"
echo -e "${BPurple}john@debian:~$ ${BRed}alias${NC}"
echo -e "alias ls='ls --color=auto'\n\n"
