#!/bin/bash
if : ; then
# File:         boolean.sh
# Name:         Kevin Crotty
# Date:         25 Mar 2019
# Desc:         Show Boolean Logic usage when running commands
# Usage:        source boolean.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

# Example demonstraion of color usage
# echo -e "${BGreen} \# \n "
# echo -e "\n${BRed} ${NC}"
fi

echo -e "\n${BRed}fdisk -l ${NC}"
fdisk -l
echo -e "\n${BRed}ls -l /dev/ | grep nbd ${NC}"
ls -l /dev/ | grep nbd
