#!/bin/bash

nbd_check_1=$(ls -l /dev/ | grep nbd)
nbd_check_2=$(fdisk -l | grep nbd)
mount_check=$(ls -l /root/Class/4/Dasboot/mnt | grep -v total)

setup ()
{
	modprobe nbd max_part=15 && sleep .2
	qemu-nbd -c /dev/nbd0 /root/Class/4/Dasboot/broke.vdi && sleep .2
	qemu-nbd -c /dev/nbd2 /root/Class/4/Dasboot/fixed.vdi && sleep .2
}
# This is a comment
choice ()
{
	echo -e "To mount broke.vdi press \"1\" to mount fixed press \"2\" or press any key to exit unmounted"
	read response
	case $response in
		1)
			setup && sleep .2
			cd /root/Class/4/Dasboot/ && sleep .2
			echo "HERE" && mount /dev/nbd0p1 /root/Class/4/Dasboot/mnt && sleep .2
			cd /root/Class/4/Dasboot/mnt && sleep .2
			;;
		2)
			setup && sleep .2
			cd /root/Class/4/Dasboot/ && sleep .2
			mount /dev/nbd2p1 /root/Class/4/Dasboot/mnt && sleep .2
			cd /root/Class/4/Dasboot/mnt && sleep .2
			;;
		*)
			;;
	esac
}

if [[ -z "$nbd_check_1" && -z "$nbd_check_2" ]] ; then
	choice && sleep .2
elif [[ -n "$nbd_check_1" && -z "$nbd_check_2" ]] ; then
	rmmod nbd && sleep .2
	choice && sleep .2
elif [[ -n "$nbd_check_1" && -n "$nbd_check_2" ]] ; then
	if [ -n "$mount_check" ] ; then
		cd /root/Class/4/Dasboot/ && sleep .2
		umount /root/Class/4/Dasboot/mnt && sleep .2
	fi
	qemu-nbd -d /dev/nbd0 &>/dev/null && sleep .2
	qemu-nbd -d /dev/nbd2 &>/dev/null && sleep .2
	rmmod nbd && sleep .2
	choice && sleep .2
fi
