#!/bin/bash

: '

Everything in between these single quotes should be commented out.

This should include spaces and new lines.

Yay bash!

'

clear

#  Opens fd(7) for reading and writing and associates it with a TCP HTTP socket
exec 6<>/dev/tcp/scanme.nmap.org/80

echo -e "\ncaldwell@debian$ exec 6<>/dev/tcp/scanme.nmap.org/80"

echo -e "\n\n========================================\n\n"

sleep 10

echo -e "caldwell@debian$ lsof -i TCP:80\n"

#  Show the fd's associated with http conection
lsof -i TCP:80 2>/dev/null

#  Sets variable 'pid' to the pid of the newly created http conection
lsof -i TCP:80 2>/dev/null | awk '$8 == "TCP" {print $1" "$2}' | grep -v awk | grep -v grep > pid.txt
pid=$(cat pid.txt | awk '{print $2}')

echo -e "\n\n========================================\n\n"

sleep 10

echo "caldwell@debian$ ls -la /proc/$pid/fd"
echo ""

#  Shows the link between the file descriptor and the inode
ls -la /proc/$pid/fd

echo -e "\n\n========================================\n\n"

sleep 10

echo "caldwell@debian$ ls -i /proc/$pid/fd/6"
echo ""

#  Gets the inode of the process
ls -i /proc/$pid/fd/6


echo -e "\n\n========================================\n\n"

sleep 10

#  Clean up files
rm pid.txt

#  Performs the HTTP GET request. Requires the \r\n\r\n and the host to work
echo -e "GET / HTTP/1.1\r\nhost: scanme.nmap.org\r\nConnection: close\r\n\r\n" >&6

echo "caldwell@debian$ echo -e 'GET / HTTP/1.1\r\nhost: scanme.nmap.org\r\nConnection: close\r\n\r\n' >&6"

echo -e "\n\n============================================\n\n"

sleep 10

echo -e "caldwell@debian$ head -n 15 <&6\n\n"

sleep 5 

#  Reads the first 20 lines of the HTTP GET request
head -n 15 <&6
